import { spawn } from 'child_process';
import { Readable } from 'stream';
import { YTDLPVideoInfo } from './types/ytdlp';
import { Track, getDurationFormatted } from './helpers';

export function convertCookieStringToYTDLPFile(cookieString: string) {
  const cookieArray = cookieString.split('; ')
  const ytdlpOptions = ['# Netscape HTTP Cookie File', '# This file is generated by yt-dlp.  Do not edit.', '']
  cookieArray.forEach(cookie => {
    const cookieParts = cookie.trim().split('=')
    if (cookieParts.length === 2) {
      ytdlpOptions.push(`.youtube.com	TRUE	/	TRUE	1893456000	${cookieParts[0]}	${cookieParts[1]}`)
    }
  })
  return ytdlpOptions.join('\n')
}

export function streamytdlp(url: string): Promise<Readable> {
  return new Promise((resolve) => {
    const ytDlp = spawn(process.env.YTDLP_PATH || 'yt-dlp', [
      '--cookies',
      'cookies.txt',
      url,
      '-f', 'bestaudio',
      '-o',
      '-',
    ], {
      stdio: 'pipe'
    });


    ytDlp.stdout.on('error', err => {
      console.error(err)
    });

    ytDlp.stderr.on('data', data => {
      console.log(`stderr: ${data}`);
    });

    ytDlp.stdout.on('error', err => {
      console.error(err)
    });

    ytDlp.on('close', code => {
      console.log(`yt-dlp exited with code ${code}`);
    });

    resolve(ytDlp.stdout)
  });
}

export function getInfoYtdlp(url: string): Promise<Track> {
  return new Promise(async (resolve, reject) => {
    const args = [
      '--cookies',
      'cookies.txt',
      '--extractor-args',
      'youtube:skip=dash',
      '--dump-json',
      '--',
      url,
    ]

    let jsonStr = ''
    let stderr = ''

    const ytDlp = spawn(process.env.YTDLP_PATH || 'yt-dlp', args, { stdio: 'pipe' });

    ytDlp.stdout.on('error', err => {
      console.error(err)
    });

    ytDlp.stderr.on('data', data => {
      console.log(`stderr: ${data}`);
      stderr += data.toString()
    });

    ytDlp.stdout.on('error', err => {
      console.error(err)
    });

    ytDlp.stdout.on('data', data => {
      try { jsonStr += data.toString() }
      catch (e: any) {
        const msg = `Failed to build JSON string for ${url}: ${e.message || e}. String size reached was ${jsonStr.length} characters and tried to add ${data.toString().length} characters`
        console.error(msg)
        console.error(jsonStr)
      }
    })

    ytDlp.on('close', code => {
      if (code === 0) {
        try {
          const video: YTDLPVideoInfo = JSON.parse(jsonStr)

          return resolve({
            cacheAlias: `${video.title.substring(0, 100)} [${video.id}]`,
            title: video.title,
            url: video.url || video.webpage_url,
            duration: Number(video.duration),
            durationFormatted: getDurationFormatted(Number(video.duration)),
            formats: video.formats
          } as Track)
        } catch (e) {
          return reject(new Error(`Failed to parse JSON from yt-dlp for ${url} and stderr: ${stderr}`))
        }
      }
      const err = new Error(stderr)
      //@ts-ignore
      err.availability = unavailableError
      //@ts-ignore
      err.source = 'Local'
      return reject(err)
    });
  });
}

export function searchWithYtdlp(url: string): Promise<Track> {
  return new Promise(async (resolve, reject) => {
    const args = [
      '--cookies',
      'cookies.txt',
      '--extractor-args',
      'youtube:skip=dash',
      `ytsearch:"${url}"`,
      '--dump-json'
    ]

    let jsonStr = ''
    let stderr = ''

    const ytDlp = spawn(process.env.YTDLP_PATH || 'yt-dlp', args, { stdio: 'pipe' });

    ytDlp.stdout.on('error', err => {
      console.error(err)
    });

    ytDlp.stderr.on('data', data => {
      console.log(`stderr: ${data}`);
      stderr += data.toString()
    });

    ytDlp.stdout.on('error', err => {
      console.error(err)
    });

    ytDlp.stdout.on('data', data => {
      try { jsonStr += data.toString() }
      catch (e: any) {
        const msg = `Failed to build JSON string for ${url}: ${e.message || e}. String size reached was ${jsonStr.length} characters and tried to add ${data.toString().length} characters`
        console.error(msg)
        console.error(jsonStr)
      }
    })

    ytDlp.on('close', code => {
      if (code === 0) {
        try {
          const video: YTDLPVideoInfo = JSON.parse(jsonStr)

          return resolve({
            cacheAlias: `${video.title.substring(0, 100)} [${video.id}]`,
            title: video.title,
            url: video.url || video.webpage_url,
            duration: Number(video.duration),
            durationFormatted: getDurationFormatted(Number(video.duration)),
            formats: video.formats
          } as Track)
        } catch (e) {
          return reject(new Error(`Failed to parse JSON from yt-dlp for ${url} and stderr: ${stderr}`))
        }
      }
      const err = new Error(stderr)
      //@ts-ignore
      err.availability = unavailableError
      //@ts-ignore
      err.source = 'Local'
      return reject(err)
    });
  });
}